{{ if false }}
# ^^^^^^^^^ BE AWARE
# this exists to toggle on schema validation in this file
apiVersion: v1
kind: Pod
metadata:
  name: dummy
spec:
{{ end }}
{{/*
this is named as "2sp" due to the leading 2 spaces as a concession to the "spec:" checking above
*/}}
{{- define "aws-discovery-svc.containers2sp" -}}
  {{- $imageTag := .Values.image.tag }}
  {{- if not $imageTag -}}
  {{-   fail "You must specify image:tag: now" -}}
  {{- end -}}
  {{- if (include "aws-discovery-svc.wantServiceAccount" .) }}
  serviceAccountName: {{ include "aws-discovery-svc.serviceAccountName" . }}
  {{- end }}
  {{ if .Values.azure.enabled }}
  volumes:
    - name: azure-identity-token
      projected:
        defaultMode: 420
        sources:
          - serviceAccountToken:
              audience: api://AzureADTokenExchange
              expirationSeconds: 86400
              path: azure-identity-token
  {{ end }}
  containers:
  - name: {{ .Chart.Name }}
    image: "{{.Values.image.registry}}/{{ .Values.image.repository }}:{{ $imageTag }}"
    {{ with .Values.command }}
    command: {{ toJson . }}
    {{ end }}
    imagePullPolicy: {{ .Values.image.pullPolicy }}
    livenessProbe:
      httpGet:
        path: /actuator/health
        port: 8080
      initialDelaySeconds: 120
      failureThreshold: 12 # Translates to 120 seconds
      periodSeconds: 10 # This is the default, setting it explicitly to make it easier reason about.
    readinessProbe:
      httpGet:
        path: /actuator/health
        port: 8080
      initialDelaySeconds: 120
    {{- with .Values.securityContext }}
    securityContext:
      {{- toYaml . | nindent 14 }}
    {{- end }}
    resources:
      {{- toYaml .Values.resources | nindent 12 }}
    {{ with .Values.envFrom }}
    envFrom: {{ toJson . }}
    {{ end }}
    env:
      - name: MANAGEMENT_SERVER_PORT
        value: "8080"
      - name: SERVER_PORT
        value: "80"
      - name: OPENRAVEN_APP_V1_SERVICES_ANALYTICS_ENABLED
        value: 'false'
      - name: OPENRAVEN_APP_V1_SERVICES_ANALYTICS_KEY
        value: {{ .Values.segment_key | quote }}
      - name: OPENRAVEN_APP_V1_SERVICES_ANALYTICS_CLUSTERID
        value: {{ .Values.global.groupId }}
      - name: SENTRY_DSN
        value: {{ .Values.sentry_dsn | quote }}
      - name: SENTRY_ENVIRONMENT
        value: {{ .Values.global.clusterName }}
      - name: SENTRY_RELEASE
        value: "{{ .Chart.Version }}"
      - name: SENTRY_EXTRA
        value: "groupId:{{ .Values.global.groupId }},service:{{ .Release.Name }},cluster_name:{{ .Values.global.clusterName }}"
      - name: JAVA_TOOL_OPTIONS
        value: {{ .Values.java.vmArgs }}
      - name: SPRING_KAFKA_CONSUMER_AUTO-OFFSET-RESET
        value: "earliest"
      - name: MANAGEMENT_ENDPOINT_HEALTH_SHOW-DETAILS
        value: {{ .Values.spring.healthShowDetails }}
      {{ if .Values.spring.patchDataSourceProperties }}
      - name: SPRING_DATASOURCE_TYPE
        {{/* we want to standardize on this not only for its metrics but also for the ApplicationName below */}}
        value: com.zaxxer.hikari.HikariDataSource
      - name: SPRING.DATASOURCE.HIKARI.REGISTER-MBEANS
        value: 'true'
      - name: SPRING_DATASOURCE_HIKARI_DATA-SOURCE-PROPERTIES
        {{/* @see org.postgresql.PGProperty.APPLICATION_NAME and org.springframework.core.convert.support.StringToPropertiesConverter */}}
        {{/* we aren't using their DATA-SOURCE-PROPERTIES[ApplicationName] syntax because the env-var does not preserve case */}}
        value: ApplicationName={{ .Release.Name }}
      {{ end }}
    {{ if .Values.azure.enabled }}
      - name: AZURE_FEDERATED_TOKEN_FILE
        value: "/var/run/secrets/azure/tokens/azure-identity-token"
    {{ end }}
      - name: SPRING_MAIN_BANNER-MODE
        value: "off"
{{ with .Values.extraEnv }}
{{- toYaml . | indent 6 }}
{{ end }}
    {{ if .Values.azure.enabled }}
    volumeMounts:
      - mountPath: "/var/run/secrets/azure/tokens"
        name: "azure-identity-token"
        readOnly: true
    {{ end }}
{{- end -}}
